<?php

function mt_members_shortcode( $atts ) {
	
	// Attributes
	extract( shortcode_atts(
		array(
			'number' => '-1',
			'category' => '',
			'columns' => '3', 
		), $atts )
	);

	// Creating custom query to fetch the project type custom post.
    $scmembers = new WP_Query( 
		array(
			'post_type' => 'member',  
			'posts_per_page' => $number, 
			'category_name' => $category
			)
		);
	
	// Looping through the posts and building the HTML structure.
    if($scmembers)	{ 
		
		$output .= '<section id="mt-members"><div class="grid grid-pad">';
		
        while ( $scmembers->have_posts() ) 
		{
			
            $scmembers->the_post();
			
			$post_meta_fb = get_post_meta( get_the_ID(), 'mt-member-facebook', TRUE );
			$post_meta_twitter = get_post_meta( get_the_ID(), 'mt-member-twitter', TRUE );
			$post_meta_linkedin = get_post_meta( get_the_ID(), 'mt-member-linkedin', TRUE );
			$post_meta_google = get_post_meta( get_the_ID(), 'mt-member-google', TRUE );
			$post_meta_vimeo = get_post_meta( get_the_ID(), 'mt-member-vimeo', TRUE );
			$post_meta_instagram = get_post_meta( get_the_ID(), 'mt-member-instagram', TRUE );
			$post_meta_behance = get_post_meta( get_the_ID(), 'mt-member-behance', TRUE );
			$post_meta_vk = get_post_meta( get_the_ID(), 'mt-member-vk', TRUE );
			$post_meta_email = get_post_meta( get_the_ID(), 'mt-member-email', TRUE );
			
             
			$output .= '<div class="col-1-' . $columns . ' mt-column-clear"><div class="member">';
			
  			$output .=  get_the_post_thumbnail( get_the_ID(), 'team-thumb' ); 
            $output .=	'<h3>'.get_the_title().'</h3>'; 
            $output .=	'<p>'.get_the_content().'</p>';
			
			if ( get_post_meta( get_the_ID(), 'mt-member-facebook', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_fb ) . '" target="_blank"><i class="fa fa-facebook"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-twitter', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_twitter ) . '" target="_blank"><i class="fa fa-twitter"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-linkedin', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_linkedin ) . '" target="_blank"><i class="fa fa-linkedin"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-google', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_google ) . '" target="_blank"><i class="fa fa-google-plus"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-vimeo', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_vimeo ) . '" target="_blank"><i class="fa fa-vimeo"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-instagram', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_instagram ) . '" target="_blank"><i class="fa fa-instagram"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-behance', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_behance ) . '" target="_blank"><i class="fa fa-behance"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-vk', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_vk ) . '" target="_blank"><i class="fa fa-vk"></i></a>';
			endif;
			
			if ( get_post_meta( get_the_ID(), 'mt-member-email', TRUE ) ): 
			$output .=	'<a href="'. esc_html( $post_meta_email ) . '" target="_blank"><i class="fa fa-envelope-o"></i></a>';
			endif; 
			
            $output .= '</div></div>'; 

        }
		
		$output .= '</div></section>';
		
    }
	
    else
        $output = __( 'Sorry, No members yet!', 'mtmembers' );     
	
	
	wp_reset_postdata();
	
	     
    return $output; 
}


add_shortcode( 'members', 'mt_members_shortcode' );

?>