<?php



class mt_members extends WP_Widget { 



// constructor

    function __construct() {

		$widget_ops = array('classname' => 'mt_members_widget', 'description' => __( 'With this widget you can display your top notch team members.', 'mtmembers') );

        parent::__construct(false, $name = __('MT - Team Members', 'mtmembers'), $widget_ops);  

		$this->alt_option_name = 'mt_members_widget'; 

		

		add_action( 'save_post', array($this, 'flush_widget_cache') ); 

		add_action( 'deleted_post', array($this, 'flush_widget_cache') );

		add_action( 'switch_theme', array($this, 'flush_widget_cache') );		

    }

	

	// widget form creation

	function form($instance) {



	// Check values

		$title     		= isset( $instance['title'] ) ? wp_kses_post( $instance['title'] ) : '';

		$number    		= isset( $instance['number'] ) ? intval( $instance['number'] ) : -1;
		
		$columnset    	= isset( $instance['columnset'] ) ? intval( $instance['columnset'] ) : 3;
		
		$category    	= isset( $instance['category'] ) ? esc_html( $instance['category'] ) : '';

		$see_all   		= isset( $instance['see_all'] ) ? esc_url_raw( $instance['see_all'] ) : '';

		$see_all_text  	= isset( $instance['see_all_text'] ) ? esc_html( $instance['see_all_text'] ) : '';	
		
	?>



	<p><?php _e('In order to display this widget, you must first add some Team Member custom post types.', 'mtmembers'); ?></p>

	<p>

	<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'mtmembers'); ?></label>

	<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo wp_kses_post( $title );  ?>" />

	</p>

	<p><label for="<?php echo $this->get_field_id( 'number' ); ?>"><?php _e( 'Number of Team Members to show (-1 shows all):', 'mtmembers' ); ?></label>

	<input id="<?php echo $this->get_field_id( 'number' ); ?>" name="<?php echo $this->get_field_name( 'number' ); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
    
    <p><label for="<?php echo $this->get_field_id( 'category' ); ?>"><?php _e( 'Category:', 'mtmembers' ); ?></label> 

	<input class="widefat" id="<?php echo $this->get_field_id( 'category' ); ?>" name="<?php echo $this->get_field_name( 'category' ); ?>" type="text" value="<?php echo $category; ?>" size="3" /></p>
    
    
    <p><label for="<?php echo $this->get_field_id( 'columnset' ); ?>"><?php _e( 'Number of columns:', 'mtmembers' ); ?></label>

	<input id="<?php echo $this->get_field_id( 'columnset' ); ?>" name="<?php echo $this->get_field_name( 'columnset' ); ?>" type="text" value="<?php echo intval( $columnset ); ?>" size="3" /></p>
    

    <p><label for="<?php echo $this->get_field_id('see_all'); ?>"><?php _e('Enter the URL for your Team Member page:', 'mtmembers'); ?></label>

	<input class="widefat custom_media_url" id="<?php echo $this->get_field_id( 'see_all' ); ?>" name="<?php echo $this->get_field_name( 'see_all' ); ?>" type="text" value="<?php echo esc_url_raw( $see_all ); ?>" size="3" /></p> 	

    <p><label for="<?php echo $this->get_field_id('see_all_text'); ?>"><?php _e('Button Text (Default is <em>See All</em>):', 'mtmembers'); ?></label>

	<input class="widefat" id="<?php echo $this->get_field_id( 'see_all_text' ); ?>" name="<?php echo $this->get_field_name( 'see_all_text' ); ?>" type="text" value="<?php echo esc_html( $see_all_text ); ?>" size="3" /></p> 

	

	<?php

	}



	// update widget

	function update($new_instance, $old_instance) {

		$instance = $old_instance;

		$instance['title'] 			= wp_kses_post($new_instance['title']);

		$instance['number'] 		= intval($new_instance['number']);
		
		$instance['category'] 		= esc_html($new_instance['category']);
		
		$instance['columnset'] 		= intval($new_instance['columnset']);

		$instance['see_all'] 		= esc_url_raw( $new_instance['see_all'] );	

		$instance['see_all_text'] 	= esc_html($new_instance['see_all_text']);
			

		$this->flush_widget_cache();



		$alloptions = wp_cache_get( 'alloptions', 'options' );

		if ( isset($alloptions['mt_members']) )

			delete_option('mt_members');		  

		  

		return $instance;

	}

	

	function flush_widget_cache() {

		wp_cache_delete('mt_members', 'widget');

	}

	

	// display widget

	function widget($args, $instance) {

		$cache = array();

		if ( ! $this->is_preview() ) {

			$cache = wp_cache_get( 'mt_members', 'widget' );

		}



		if ( ! is_array( $cache ) ) {

			$cache = array();

		}



		if ( ! isset( $args['widget_id'] ) ) {

			$args['widget_id'] = $this->id;

		}



		if ( isset( $cache[ $args['widget_id'] ] ) ) {

			echo $cache[ $args['widget_id'] ];

			return;

		}



		ob_start();

		extract($args);


		/** This filter is documented in wp-includes/default-widgets.php */

		$title = isset( $instance['title'] ) ? wp_kses_post($instance['title']) : ''; 

		$see_all 		= isset( $instance['see_all'] ) ? esc_url($instance['see_all']) : '';

		$see_all_text 	= isset( $instance['see_all_text'] ) ? esc_html($instance['see_all_text']) : '';
		
		$category 		= isset( $instance['category'] ) ? esc_html($instance['category']) : '';

		$number 		= ( ! empty( $instance['number'] ) ) ? intval( $instance['number'] ) : -1;

		if ( ! $number ) {

			$number = -1;

		}
		
		$columnset 		= ( ! empty( $instance['columnset'] ) ) ? intval( $instance['columnset'] ) : 3;
		
		if ( ! $columnset ) {

			$columnset = 3;

		}


		$mt = new WP_Query( apply_filters( 'widget_posts_args', array(

			'no_found_rows'       => true,

			'post_status'         => 'publish',

			'post_type' 		  => 'member',
			
			'category_name'       => $category,

			'posts_per_page'	  => $number

		) ) );



		if ($mt->have_posts()) :

?>


		<section id="mt-members">

			
			<?php if ( $title ) : ?>
				
				<div class="grid grid-pad">
        			<div class="col-1-1">
				
					<?php echo $before_title .  wp_kses_post( $title ) . $after_title; ?>
                    
                	</div>
        		</div>
                
            <?php endif; ?>
            
            
            <div class="grid grid-pad">
	

				<?php while ( $mt->have_posts() ) : $mt->the_post(); ?>
                
                	<div class="col-1-<?php if ( $columnset ) echo $columnset; ?> mt-column-clear"> 
                		<div class="member">
                        
                        	<?php the_post_thumbnail('team-thumb'); ?>
                			<?php the_title( '<h3>', '</h3>' ); ?> 
                            <?php the_content( '<p>', '</p>' ); ?>
                            
                            <?php if (get_post_meta( get_the_ID(), 'mt-member-facebook', true ) ): ?> 
                            
                            	<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-facebook', true ); echo $text; ?>" target="_blank"><i class="fa fa-facebook"></i></a>
                                
                    		<?php endif; ?> 
                    
                    		<?php if (get_post_meta( get_the_ID(), 'mt-member-twitter', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-twitter', true ); echo $text; ?>" target="_blank"><i class="fa fa-twitter"></i></a>
                                
                    		<?php endif; ?>
                    
                    		<?php if (get_post_meta( get_the_ID(), 'mt-member-linkedin', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-linkedin', true ); echo $text; ?>" target="_blank"><i class="fa fa-linkedin"></i></a>
                                
                    		<?php endif; ?>
                    
                    		<?php if (get_post_meta( get_the_ID(), 'mt-member-google', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-google', true ); echo $text; ?>" target="_blank"><i class="fa fa-google-plus"></i></a>
                                
                    		<?php endif; ?>
                            
                            <?php if (get_post_meta( get_the_ID(), 'mt-member-vimeo', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-vimeo', true ); echo $text; ?>" target="_blank"><i class="fa fa-vimeo"></i></a>
                                
                    		<?php endif; ?>
                            
                            <?php if (get_post_meta( get_the_ID(), 'mt-member-instagram', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-instagram', true ); echo $text; ?>" target="_blank"><i class="fa fa-instagram"></i></a>
                                
                    		<?php endif; ?>
                            
                             <?php if (get_post_meta( get_the_ID(), 'mt-member-behance', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-behance', true ); echo $text; ?>" target="_blank"><i class="fa fa-behance"></i></a>
                                
                    		<?php endif; ?>
                            
                            <?php if (get_post_meta( get_the_ID(), 'mt-member-vk', true ) ): ?>
                            
                    			<a href="<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-vk', true ); echo $text; ?>" target="_blank"><i class="fa fa-vk"></i></a> 
                                
                    		<?php endif; ?>
                    
                    		<?php if (get_post_meta( get_the_ID(), 'mt-member-email', true ) ): ?>
                            
                    			<a href="mailto:<?php global $post; $text = get_post_meta( get_the_ID(), 'mt-member-email', true ); echo $text; ?>" target="_blank"><i class="fa fa-envelope-o"></i></a>
                                
                    		<?php endif; ?>
                            
                    	</div>
                	</div>

				<?php endwhile; ?>

			</div>

			<?php if ($see_all != '') : ?>

				<a href="<?php echo esc_url($see_all); ?>" class="mtmembers-home-widget">

					<?php if ($see_all_text) : ?>

						<button><?php echo esc_html( $see_all_text ); ?></button>

					<?php else : ?>

						<button><?php echo __('See All', 'mtmembers'); ?></button> 

					<?php endif; ?>

				</a>

			<?php endif; ?>
			

		</section>		

	<?php

		// Reset the global $the_post as this query will have stomped on it

		wp_reset_postdata();



		endif;



		if ( ! $this->is_preview() ) {

			$cache[ $args['widget_id'] ] = ob_get_flush();

			wp_cache_set( 'mt_members', $cache, 'widget' );

		} else {

			ob_end_flush();

		}

	}

	

}